
angular.module('app').controller('BaseCtrl', [
    '$scope',
    '$http',
    '$location',
    '$rootScope',

    function($scope, $http, $location, $rootScope) {
        $scope.logout = function() {
            $http.post("/api/logout")
                .then(function (res) {
                    console.log("success: " + res);
                    $rootScope.user = null;
                    $location.url('/login');
                }, function (err) {
                    console.log("error: " + err);
                });
        };

        // Not used for now. Similar function in vendorRouteCtrl.js called from local button if boss
        $scope.rebuildRouting = function() {
            $http.post("/api/v1/rebuildVendorRouteAppTable")
                .then(function (res) {
                    console.log("success: " + res);
                }, function (err) {
                    console.log("error: " + JSON.stringify(err, null, 4));
                });
        };

        $scope.isAdmin = function() {
            if ($rootScope.user) {
                return $rootScope.user.isAdmin;
            } else {
                return false;
            }
        };

        $scope.isBoss = function() {
            if ($rootScope.user) {
                return $rootScope.user.isBoss;
            } else {
                return false;
            }
        };

        $scope.isAdminOrBoss = function() {
            if ($rootScope.user) {
                return $rootScope.user.isAdminOrBoss;
            } else {
                return false;
            }
        };

        $scope.getClass = function() {
            if($scope.isBoss()){
                return "standard__item nav-wrap-boss";
            } else if($scope.isAdmin()){
                return "standard__item nav-wrap-admin";
            } else{
                return "standard__item nav-wrap";
            }
        };
    }]);
